{
    "$graph": [
        {
            "class": "CommandLineTool",
            "label": "bwa-mem",
            "doc": "BWA is a software package for mapping DNA sequences against a large reference genome",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/bwa:0.7.17--h84994c4_5",
                    "id": "#bwa-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "bwa",
                            "version": [
                                "0.7.17"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/bwa"
                            ]
                        }
                    ],
                    "id": "#bwa-bioconda.yml"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMin": "$(inputs.t)",
                    "ramMin": 10240,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-A",
                        "separate": false
                    },
                    "id": "#bwa-mem.cwl/A"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-B",
                        "separate": false
                    },
                    "id": "#bwa-mem.cwl/B"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-E",
                        "separate": false
                    },
                    "id": "#bwa-mem.cwl/E"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-K"
                    },
                    "id": "#bwa-mem.cwl/K"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-L",
                        "separate": false
                    },
                    "id": "#bwa-mem.cwl/L"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-M"
                    },
                    "id": "#bwa-mem.cwl/M"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-P"
                    },
                    "id": "#bwa-mem.cwl/P"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-R"
                    },
                    "id": "#bwa-mem.cwl/R"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-S"
                    },
                    "id": "#bwa-mem.cwl/S"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-T"
                    },
                    "id": "#bwa-mem.cwl/T"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-Y"
                    },
                    "id": "#bwa-mem.cwl/Y"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-a"
                    },
                    "id": "#bwa-mem.cwl/a"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-5"
                    },
                    "id": "#bwa-mem.cwl/five"
                },
                {
                    "type": "Directory",
                    "id": "#bwa-mem.cwl/index"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4,
                        "valueFrom": "${\n  return inputs.index.path + \"/\" + self;\n}\n"
                    },
                    "id": "#bwa-mem.cwl/prefix"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#bwa-mem.cwl/reads"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-t"
                    },
                    "id": "#bwa-mem.cwl/t"
                }
            ],
            "stdout": "${\n  var nameroot = inputs.reads[0].nameroot;\n  if (nameroot.endsWith(\".fastq\")){\n    nameroot = nameroot.replace(\".fastq\", \"\");\n  }else if (nameroot.endsWith(\".fq\")){\n    nameroot = nameroot.replace(\".fq\", \"\");\n  }\n  if (nameroot.endsWith(\"_1\") || nameroot.endsWith(\"_2\")){\n    nameroot = nameroot.slice(0, -2);\n  }else if (nameroot.includes(\"_R1_\")){\n    nameroot = nameroot.substring(0, nameroot.indexOf(\"_R1_\"))\n  }else if (nameroot.includes(\"_R2_\")){\n    nameroot = nameroot.substring(0, nameroot.indexOf(\"_R2_\"))\n  }\n  return nameroot + '.sam';\n}\n",
            "baseCommand": [
                "bwa",
                "mem"
            ],
            "id": "#bwa-mem.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  var nameroot = inputs.reads[0].nameroot;\n  if (nameroot.endsWith(\".fastq\")){\n    nameroot = nameroot.replace(\".fastq\", \"\");\n  }else if (nameroot.endsWith(\".fq\")){\n    nameroot = nameroot.replace(\".fq\", \"\");\n  }\n  if (nameroot.endsWith(\"_1\") || nameroot.endsWith(\"_2\")){\n    nameroot = nameroot.slice(0, -2);\n  }else if (nameroot.includes(\"_R1_\")){\n    nameroot = nameroot.substring(0, nameroot.indexOf(\"_R1_\"))\n  }else if (nameroot.includes(\"_R2_\")){\n    nameroot = nameroot.substring(0, nameroot.indexOf(\"_R2_\"))\n  }\n  return nameroot + '.sam';\n}\n"
                    },
                    "id": "#bwa-mem.cwl/out_stdout"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "Samtools-flagstat",
            "doc": "Samtools is a suite of programs for interacting with high-throughput sequencing data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/samtools:1.10--h9402c20_2",
                    "id": "#samtools-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "samtools",
                            "version": [
                                "1.10"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/samtools"
                            ]
                        }
                    ],
                    "id": "#samtools-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#samtools-flagstat.cwl/in_bam"
                },
                {
                    "type": "string",
                    "id": "#samtools-flagstat.cwl/stdout"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.stdout)"
                    },
                    "id": "#samtools-flagstat.cwl/out_stdout"
                }
            ],
            "stdout": "$(inputs.stdout)",
            "baseCommand": [
                "samtools",
                "flagstat"
            ],
            "id": "#samtools-flagstat.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "Samtools-stats",
            "doc": "Samtools is a suite of programs for interacting with high-throughput sequencing data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#samtools-docker.yml"
                },
                {
                    "$import": "#samtools-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "id": "#samtools-stats.cwl/in_bam",
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    }
                },
                {
                    "id": "#samtools-stats.cwl/stdout",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#samtools-stats.cwl/out_stdout",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.stdout)"
                    }
                }
            ],
            "stdout": "$(inputs.stdout)",
            "baseCommand": [
                "samtools",
                "stats"
            ],
            "id": "#samtools-stats.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "Samtools-view",
            "doc": "Samtools is a suite of programs for interacting with high-throughput sequencing data",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMin": "$(inputs.threads)",
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#samtools-docker.yml"
                },
                {
                    "$import": "#samtools-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-S"
                    },
                    "doc": "input format is auto-detected\n",
                    "id": "#samtools-view.cwl/S"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-L"
                    },
                    "doc": "only include reads overlapping this BED FILE [null]\n",
                    "id": "#samtools-view.cwl/bedoverlap"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-m"
                    },
                    "doc": "only include reads with number of CIGAR operations\nconsuming query sequence >= INT [0]\n",
                    "id": "#samtools-view.cwl/cigar"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-B"
                    },
                    "doc": "collapse the backward CIGAR operation\n",
                    "id": "#samtools-view.cwl/collapsecigar"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-c"
                    },
                    "doc": "print only the count of matching records\n",
                    "id": "#samtools-view.cwl/count"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-1"
                    },
                    "doc": "use fast BAM compression (implies -b)\n",
                    "id": "#samtools-view.cwl/fastcompression"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "Input bam file.\n",
                    "id": "#samtools-view.cwl/input"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-b"
                    },
                    "doc": "output in BAM format\n",
                    "id": "#samtools-view.cwl/isbam"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-C"
                    },
                    "doc": "output in CRAM format\n",
                    "id": "#samtools-view.cwl/iscram"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-o"
                    },
                    "id": "#samtools-view.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-s"
                    },
                    "doc": "integer part sets seed of random number generator [0];\nrest sets fraction of templates to subsample [no subsampling]\n",
                    "id": "#samtools-view.cwl/randomseed"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-r"
                    },
                    "doc": "only include reads in read group STR [null]\n",
                    "id": "#samtools-view.cwl/readsingroup"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-R"
                    },
                    "doc": "only include reads with read group listed in FILE [null]\n",
                    "id": "#samtools-view.cwl/readsingroupfile"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-l"
                    },
                    "doc": "only include reads in library STR [null]\n",
                    "id": "#samtools-view.cwl/readsinlibrary"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-q"
                    },
                    "doc": "only include reads with mapping quality >= INT [0]\n",
                    "id": "#samtools-view.cwl/readsquality"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-f"
                    },
                    "doc": "only include reads with all bits set in INT set in FLAG [0]\n",
                    "id": "#samtools-view.cwl/readswithbits"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-F"
                    },
                    "doc": "only include reads with none of the bits set in INT set in FLAG [0]\n",
                    "id": "#samtools-view.cwl/readswithoutbits"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "read tag to strip (repeatable) [null]\n",
                    "id": "#samtools-view.cwl/readtagtostrip"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-T"
                    },
                    "doc": "reference sequence FASTA FILE [null]\n",
                    "id": "#samtools-view.cwl/referencefasta"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 5
                    },
                    "doc": "[region ...]\n",
                    "id": "#samtools-view.cwl/region"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-h"
                    },
                    "doc": "include header in SAM output\n",
                    "id": "#samtools-view.cwl/samheader"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-@"
                    },
                    "doc": "number of BAM compression threads [0]\n",
                    "id": "#samtools-view.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-u"
                    },
                    "doc": "uncompressed BAM output (implies -b)\n",
                    "id": "#samtools-view.cwl/uncompressed"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#samtools-view.cwl/output"
                }
            ],
            "baseCommand": [
                "samtools",
                "view"
            ],
            "id": "#samtools-view.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#main",
            "doc": "This workflow aligns the fastq files using bwa",
            "label": "bwa alignment workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#main/genome_index"
                },
                {
                    "type": "string",
                    "id": "#main/genome_prefix"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/reads"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/threads"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#main/samtools_flagstat/out_stdout",
                    "type": "File",
                    "id": "#main/bam_flagstat_out"
                },
                {
                    "outputSource": "#main/samtools_view/output",
                    "type": "File",
                    "id": "#main/bam_out"
                },
                {
                    "outputSource": "#main/samtools_stats/out_stdout",
                    "type": "File",
                    "id": "#main/bam_stats_out"
                }
            ],
            "steps": [
                {
                    "run": "#bwa-mem.cwl",
                    "label": "bwa-mem",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/bwa_mem/M"
                        },
                        {
                            "source": "#main/genome_index",
                            "id": "#main/bwa_mem/index"
                        },
                        {
                            "source": "#main/genome_prefix",
                            "id": "#main/bwa_mem/prefix"
                        },
                        {
                            "source": "#main/reads",
                            "id": "#main/bwa_mem/reads"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/bwa_mem/t"
                        }
                    ],
                    "out": [
                        "#main/bwa_mem/out_stdout"
                    ],
                    "id": "#main/bwa_mem"
                },
                {
                    "run": "#samtools-flagstat.cwl",
                    "label": "Samtools-flagstat",
                    "in": [
                        {
                            "source": "#main/samtools_view/output",
                            "id": "#main/samtools_flagstat/in_bam"
                        },
                        {
                            "valueFrom": "${ return inputs.in_bam.nameroot + \".flagstat\";}",
                            "id": "#main/samtools_flagstat/stdout"
                        }
                    ],
                    "out": [
                        "#main/samtools_flagstat/out_stdout"
                    ],
                    "id": "#main/samtools_flagstat"
                },
                {
                    "run": "#samtools-stats.cwl",
                    "label": "Samtools-stats",
                    "in": [
                        {
                            "source": "#main/samtools_view/output",
                            "id": "#main/samtools_stats/in_bam"
                        },
                        {
                            "valueFrom": "${ return inputs.in_bam.nameroot + \".stats\";}",
                            "id": "#main/samtools_stats/stdout"
                        }
                    ],
                    "out": [
                        "#main/samtools_stats/out_stdout"
                    ],
                    "id": "#main/samtools_stats"
                },
                {
                    "run": "#samtools-view.cwl",
                    "label": "Samtools-view",
                    "in": [
                        {
                            "source": "#main/bwa_mem/out_stdout",
                            "id": "#main/samtools_view/input"
                        },
                        {
                            "default": true,
                            "id": "#main/samtools_view/isbam"
                        },
                        {
                            "valueFrom": "${ return inputs.input.nameroot + \".bam\";}",
                            "id": "#main/samtools_view/output_name"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/samtools_view/threads"
                        }
                    ],
                    "out": [
                        "#main/samtools_view/output"
                    ],
                    "id": "#main/samtools_view"
                }
            ],
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "https://schema.org/version/latest/schemaorg-current-http.rdf"
    ],
    "$namespaces": {
        "s": "http://schema.org/"
    }
}
